"{ Package: 'stx:goodies/metacello/stx' }"

MetacelloSpec subclass:#MetacelloStXRepositorySpec
	instanceVariableNames:'name type url username password keyfile'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-St/X-Specs'
!


!MetacelloStXRepositorySpec methodsFor:'accessing'!

name
    ^ name
!

name:aString
    name := aString.
!

type
    ^ type
!

type: anObject
    anObject setTypeInMetacelloStXRepository: self

    "Modified: / 03-10-2012 / 11:42:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

url
    ^ url

    "Created: / 03-10-2012 / 12:47:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

url: anObject
    anObject setUrlInMetacelloStXRepository: self

    "Created: / 03-10-2012 / 11:42:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloStXRepositorySpec methodsFor:'accessing-private'!

getType
    ^ type

    "Created: / 03-10-2012 / 11:40:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

getUrl
    ^ url

    "Created: / 03-10-2012 / 11:40:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setType: anObject
    type := anObject

    "Created: / 03-10-2012 / 11:41:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setUrl: anObject
    url := anObject

    "Created: / 03-10-2012 / 11:41:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloStXRepositorySpec methodsFor:'construction'!

type: aBlockOrString constructor: aVersionConstructor
     aVersionConstructor typeForVersion: aBlockOrString

    "Created: / 03-10-2012 / 11:34:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

url: aBlockOrString constructor: aVersionConstructor
     aVersionConstructor urlForVersion: aBlockOrString

    "Created: / 03-10-2012 / 11:35:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloStXRepositorySpec methodsFor:'merging'!

mergeIntoMetacelloRepositories: aMetacelloRepositoriesSpec

    aMetacelloRepositoriesSpec addMember: 
        (aMetacelloRepositoriesSpec mergeMember 
            name: self name;
            spec: self;
            yourself)

    "Created: / 03-10-2012 / 11:11:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloStXRepositorySpec methodsFor:'printing'!

configMethodOn:aStream indent:indent

    aStream 
        tab: indent; nextPutAll: 'spec '; nextPutAll: 'name: ', self name storeString.

    (type ? url) notNil ifTrue:[
        aStream 
            nextPutAll: ' with: [' ; cr.
            type notNil ifTrue:[
                aStream tab: indent + 1; nextPutAll: 'spec type: '; nextPutAll: self type value storeString; nextPut:$.; cr.
            ].
            url notNil ifTrue:[
                aStream tab: indent + 1; nextPutAll: 'spec url: '; nextPutAll: self url value storeString; nextPut:$.; cr.
            ].
            aStream tab: indent; nextPutAll: '].' ; cr.
    ] ifFalse:[
        aStream nextPut: $. ; cr.
    ]

    "Modified: / 03-10-2012 / 12:48:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloStXRepositorySpec class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
